MyGUI: MyGUI::ItemBox Class Reference

MyGUI 3.4.3

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Types | Protected Member Functions
MyGUI::ItemBox Class Reference

widget description should be here. More...

`#include <MyGUI_ItemBox.h>`

Inheritance diagram for MyGUI::ItemBox:
[legend]

## Data Structures
struct | ItemDataInfo

## Public Types
typedef RTTIBase | Base
typedef ItemBox | RTTIBase
Public Types inherited from MyGUI::DDContainer
typedef RTTIBase | Base
typedef DDContainer | RTTIBase
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
| ItemBox ()
size_t | getItemCount () const
| Get number of items.
void | insertItemAt (size_t _index, Any _data=Any::Null, bool update=true)
| Insert an item into a array at a specified position.
void | addItem (Any _data=Any::Null, bool update=true)
| Add an item to the end of a array.
void | removeItemAt (size_t _index, bool update=true)
| Remove item at a specified position.
void | removeAllItems ()
| Remove all items.
void | redrawItemAt (size_t _index)
| Redraw at a specified position.
void | redrawAllItems ()
| Redraw all items.
size_t | getIndexSelected () const
| Get index of selected item (ITEM_NONE if none selected)
void | setIndexSelected (size_t _index)
| Select specified _index.
void | clearIndexSelected ()
| Clear item selection.
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position.
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position.
template<typename ValueType>
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position.
void | setVerticalAlignment (bool _vert)
bool | getVerticalAlignment () const
size_t | getIndexByWidget (Widget *_widget) const
Widget * | getWidgetDrag () const
Widget * | getWidgetByIndex (size_t _index)
void | resetDrag ()
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setVisibleVScroll (bool _value)
bool | isVisibleVScroll () const
void | setVisibleHScroll (bool _value)
bool | isVisibleHScroll () const
void | setViewOffset (const IntPoint &_value)
IntPoint | getViewOffset () const
IntSize | getViewSize () const override
void | _resetContainer (bool _update) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
Public Member Functions inherited from MyGUI::DDContainer
template<typename Type>
bool | isType () const
void | setNeedDragDrop (bool _value)
bool | getNeedDragDrop () const
void | resetDrag ()
Public Member Functions inherited from MyGUI::Widget
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::MemberObsolete< ItemBox >
size_t | getItemIndexSelected () const
void | setItemSelectedAt (size_t _index)
void | clearItemSelected ()
void | insertItem (size_t _index, Any _data=Any::Null)
void | setItemData (size_t _index, Any _data)
void | deleteItem (size_t _index)
void | deleteAllItems ()
size_t | getItemSelect () const
void | resetItemSelect ()
void | setItemSelect (size_t _index)
Widget * | getWidgetDrop () const
void | resetDrop ()
void | setItemBoxAlignVert (bool _value)
bool | getItemBoxAlignVert () const

## Static Public Member Functions
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::DDContainer
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Data Fields
EventHandle_ItemBoxPtrWidgetPtr | requestCreateWidgetItem
EventHandle_ItemBoxPtrIntCoordRefBool | requestCoordItem
EventHandle_ItemBoxPtrWidgetPtrCIBCellDrawInfoRef | requestDrawItem
EventHandle_ItemBoxPtrSizeT | eventSelectItemAccept
EventHandle_ItemBoxPtrSizeT | eventChangeItemPosition
EventHandle_ItemBoxPtrSizeT | eventMouseItemActivate
EventHandle_ItemBoxPtrCIBNotifyCellDataRef | eventNotifyItem
Data Fields inherited from MyGUI::DDContainer
EventHandle_DDContainerPtrCDDItemInfoRefBoolRef | eventStartDrag
EventHandle_DDContainerPtrCDDItemInfoRefBoolRef | eventRequestDrop
EventHandle_DDContainerPtrCDDItemInfoRefBool | eventDropResult
EventHandle_EventHandle_DDContainerPtrDDItemState | eventChangeDDState
EventHandle_EventHandle_DDContainerPtrWidgetPtrRefIntCoordRef | requestDragWidgetInfo
delegates::MultiDelegate< DDContainer * > | _eventInvalideContainer
delegates::MultiDelegate< DDContainer *, Widget *, const DDWidgetState & > | eventUpdateDropState
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Types
using | VectorItemInfo = std::vector<ItemDataInfo>

## Protected Member Functions
void | initialiseOverride () override
void | shutdownOverride () override
void | onMouseButtonPressed (int _left, int _top, MouseButton _id) override
void | onMouseButtonReleased (int _left, int _top, MouseButton _id) override
void | onKeyButtonPressed (KeyCode _key, Char _char) override
void | onKeyButtonReleased (KeyCode _key) override
void | onMouseDrag (int _left, int _top, MouseButton _id) override
void | onMouseWheel (int _rel) override
void | onKeyLostFocus (Widget *_new) override
void | onKeySetFocus (Widget *_old) override
void | notifyKeyButtonPressed (Widget *_sender, KeyCode _key, Char _char)
void | notifyKeyButtonReleased (Widget *_sender, KeyCode _key)
void | notifyScrollChangePosition (ScrollBar *_sender, size_t _index)
void | notifyMouseWheel (Widget *_sender, int _rel)
void | notifyRootMouseChangeFocus (Widget *_sender, bool _focus)
void | notifyMouseButtonDoubleClick (Widget *_sender)
size_t | _getItemIndex (Widget *_item) const override
void | notifyMouseDrag (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseButtonPressed (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseButtonReleased (Widget *_sender, int _left, int _top, MouseButton _id)
void | removeDropItems () override
void | updateDropItems () override
void | updateDropItemsState (const DDWidgetState &_state) override
void | updateMetrics ()
void | _updateAllVisible (bool _redraw)
void | updateFromResize ()
Widget * | getItemWidget (size_t _index)
void | _setContainerItemInfo (size_t _index, bool _set, bool _accept) override
void | resetCurrentActiveItem ()
void | findCurrentActiveItem ()
size_t | _getContainerIndex (const IntPoint &_point) const override
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::DDContainer
virtual void | notifyInvalideDrop (DDContainer *_sender)
void | mouseDrag (MouseButton _id)
void | mouseButtonReleased (MouseButton _id)
void | mouseButtonPressed (MouseButton _id)
void | endDrop (bool _reset)
Protected Member Functions inherited from MyGUI::Widget
| ~Widget () override=default
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)
Protected Member Functions inherited from MyGUI::ScrollViewBase
virtual | ~ScrollViewBase ()=default
void | updateScrollSize ()
void | updateScrollPosition ()
Protected Member Functions inherited from MyGUI::MemberObsolete< ItemBox >
size_t | getItemIndexSelected () const
void | setItemSelectedAt (size_t _index)
void | clearItemSelected ()
void | insertItem (size_t _index, Any _data=Any::Null)
void | setItemData (size_t _index, Any _data)
void | deleteItem (size_t _index)
void | deleteAllItems ()
size_t | getItemSelect () const
void | resetItemSelect ()
void | setItemSelect (size_t _index)
Widget * | getWidgetDrop () const
void | resetDrop ()
void | setItemBoxAlignVert (bool _value)
bool | getItemBoxAlignVert () const

## Additional Inherited Members
Protected Attributes inherited from MyGUI::DDContainer
bool | mDropResult {false}
bool | mNeedDrop {false}
bool | mStartDrop {false}
Widget * | mOldDrop {nullptr}
DDItemInfo | mDropInfo
size_t | mDropSenderIndex {ITEM_NONE}
Widget * | mDropItem {nullptr}
IntCoord | mDropDimension
IntPoint | mClickInWidget
bool | mNeedDragDrop {false}
DDContainer * | mReseiverContainer {nullptr}
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}
Protected Attributes inherited from MyGUI::ScrollViewBase
ScrollBar * | mVScroll {nullptr}
ScrollBar * | mHScroll {nullptr}
Widget * | mScrollViewClient {nullptr}
bool | mVisibleHScroll {true}
bool | mVisibleVScroll {true}
size_t | mVRange {0}
size_t | mHRange {0}
bool | mChangeContentByResize {false}

## Detailed Description

widget description should be here.

Definition at line 30 of file MyGUI_ItemBox.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::ItemBox::Base

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ RTTIBase

typedef ItemBox MyGUI::ItemBox::RTTIBase

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ VectorItemInfo

using MyGUI::ItemBox::VectorItemInfo = std::vector<ItemDataInfo>
| protected

Definition at line 209 of file MyGUI_ItemBox.h.

## Constructor & Destructor Documentation

## ◆ ItemBox()

MyGUI::ItemBox::ItemBox | ( |  | ) |

Definition at line 19 of file MyGUI_ItemBox.cpp.

## Member Function Documentation

## ◆ _getContainerIndex()

size_t MyGUI::ItemBox::_getContainerIndex | ( | const IntPoint & | _point | ) | const
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 489 of file MyGUI_ItemBox.cpp.

## ◆ _getItemIndex()

size_t MyGUI::ItemBox::_getItemIndex | ( | Widget * | _item | ) | const
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 282 of file MyGUI_ItemBox.cpp.

## ◆ _resetContainer()

void MyGUI::ItemBox::_resetContainer | ( | bool | _update | ) |
| overridevirtual

Reimplemented from MyGUI::Widget.

Definition at line 504 of file MyGUI_ItemBox.cpp.

## ◆ _setContainerItemInfo()

void MyGUI::ItemBox::_setContainerItemInfo | ( | size_t | _index,
|  | bool | _set,
|  | bool | _accept )
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 292 of file MyGUI_ItemBox.cpp.

## ◆ _updateAllVisible()

void MyGUI::ItemBox::_updateAllVisible | ( | bool | _redraw | ) |
| protected

Definition at line 117 of file MyGUI_ItemBox.cpp.

## ◆ addItem()

void MyGUI::ItemBox::addItem | ( | Any | _data = Any::Null,
|  | bool | update = true )

Add an item to the end of a array.

Definition at line 878 of file MyGUI_ItemBox.cpp.

## ◆ clearIndexSelected()

void MyGUI::ItemBox::clearIndexSelected | ( |  | ) |

Clear item selection.

Definition at line 888 of file MyGUI_ItemBox.cpp.

## ◆ clearItemDataAt()

void MyGUI::ItemBox::clearItemDataAt | ( | size_t | _index | ) |

Clear an item data at a specified position.

Definition at line 893 of file MyGUI_ItemBox.cpp.

## ◆ findCurrentActiveItem()

void MyGUI::ItemBox::findCurrentActiveItem | ( |  | ) |
| protected

Definition at line 247 of file MyGUI_ItemBox.cpp.

## ◆ getClassTypeName()

std::string_view MyGUI::ItemBox::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ getIndexByWidget()

size_t MyGUI::ItemBox::getIndexByWidget | ( | Widget * | _widget | ) | const

Get item index by item Widget pointer

Definition at line 476 of file MyGUI_ItemBox.cpp.

## ◆ getIndexSelected()

size_t MyGUI::ItemBox::getIndexSelected | ( |  | ) | const

Get index of selected item (ITEM_NONE if none selected)

Definition at line 883 of file MyGUI_ItemBox.cpp.

## ◆ getItemCount()

size_t MyGUI::ItemBox::getItemCount | ( |  | ) | const

Get number of items.

Definition at line 873 of file MyGUI_ItemBox.cpp.

## ◆ getItemDataAt()

template<typename ValueType>

ValueType * MyGUI::ItemBox::getItemDataAt | ( | size_t | _index,
|  | bool | _throw = true )
| inline

Get item data from specified position.

Definition at line 86 of file MyGUI_ItemBox.h.

## ◆ getItemWidget()

Widget * MyGUI::ItemBox::getItemWidget | ( | size_t | _index | ) |
| protected

Definition at line 171 of file MyGUI_ItemBox.cpp.

## ◆ getTypeName()

virtual std::string_view MyGUI::ItemBox::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::DDContainer.

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ getVerticalAlignment()

bool MyGUI::ItemBox::getVerticalAlignment | ( |  | ) | const

Get vertical alignment grid mode flag

Definition at line 898 of file MyGUI_ItemBox.cpp.

## ◆ getViewOffset()

IntPoint MyGUI::ItemBox::getViewOffset | ( |  | ) | const

Get view area offset.

Definition at line 1014 of file MyGUI_ItemBox.cpp.

## ◆ getViewSize()

IntSize MyGUI::ItemBox::getViewSize | ( |  | ) | const
| overridevirtual

Reimplemented from MyGUI::ScrollViewBase.

Definition at line 848 of file MyGUI_ItemBox.cpp.

## ◆ getWidgetByIndex()

Widget * MyGUI::ItemBox::getWidgetByIndex | ( | size_t | _index | ) |

Get item Widget pointer by item index if it is visible

Note
  returned widget can be deleted, so this pointer is valid only at time when you got it and can be invalid next frame

Definition at line 519 of file MyGUI_ItemBox.cpp.

## ◆ getWidgetDrag()

Widget * MyGUI::ItemBox::getWidgetDrag | ( |  | ) | const

Get widget created for drop

Definition at line 903 of file MyGUI_ItemBox.cpp.

## ◆ initialiseOverride()

void MyGUI::ItemBox::initialiseOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 24 of file MyGUI_ItemBox.cpp.

## ◆ insertItemAt()

void MyGUI::ItemBox::insertItemAt | ( | size_t | _index,
|  | Any | _data = Any::Null,
|  | bool | update = true )

Insert an item into a array at a specified position.

Definition at line 324 of file MyGUI_ItemBox.cpp.

## ◆ isType() [1/2]

template<typename Type>

bool MyGUI::ItemBox::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ isType() [2/2]

virtual bool MyGUI::ItemBox::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::DDContainer.

Definition at line 32 of file MyGUI_ItemBox.h.

## ◆ isVisibleHScroll()

bool MyGUI::ItemBox::isVisibleHScroll | ( |  | ) | const

Get Show HScroll flag

Definition at line 925 of file MyGUI_ItemBox.cpp.

## ◆ isVisibleVScroll()

bool MyGUI::ItemBox::isVisibleVScroll | ( |  | ) | const

Get Show VScroll flag

Definition at line 920 of file MyGUI_ItemBox.cpp.

## ◆ notifyKeyButtonPressed()

void MyGUI::ItemBox::notifyKeyButtonPressed | ( | Widget * | _sender,
|  | KeyCode | _key,
|  | Char | _char )
| protected

Definition at line 466 of file MyGUI_ItemBox.cpp.

## ◆ notifyKeyButtonReleased()

void MyGUI::ItemBox::notifyKeyButtonReleased | ( | Widget * | _sender,
|  | KeyCode | _key )
| protected

Definition at line 471 of file MyGUI_ItemBox.cpp.

## ◆ notifyMouseButtonDoubleClick()

void MyGUI::ItemBox::notifyMouseButtonDoubleClick | ( | Widget * | _sender | ) |
| protected

Definition at line 449 of file MyGUI_ItemBox.cpp.

## ◆ notifyMouseButtonPressed()

void MyGUI::ItemBox::notifyMouseButtonPressed | ( | Widget * | _sender,
|  | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| protected

Definition at line 604 of file MyGUI_ItemBox.cpp.

## ◆ notifyMouseButtonReleased()

void MyGUI::ItemBox::notifyMouseButtonReleased | ( | Widget * | _sender,
|  | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| protected

Definition at line 642 of file MyGUI_ItemBox.cpp.

## ◆ notifyMouseDrag()

void MyGUI::ItemBox::notifyMouseDrag | ( | Widget * | _sender,
|  | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| protected

Definition at line 599 of file MyGUI_ItemBox.cpp.

## ◆ notifyMouseWheel()

void MyGUI::ItemBox::notifyMouseWheel | ( | Widget * | _sender,
|  | int | _rel )
| protected

Definition at line 733 of file MyGUI_ItemBox.cpp.

## ◆ notifyRootMouseChangeFocus()

void MyGUI::ItemBox::notifyRootMouseChangeFocus | ( | Widget * | _sender,
|  | bool | _focus )
| protected

Definition at line 653 of file MyGUI_ItemBox.cpp.

## ◆ notifyScrollChangePosition()

void MyGUI::ItemBox::notifyScrollChangePosition | ( | ScrollBar * | _sender,
|  | size_t | _index )
| protected

Definition at line 719 of file MyGUI_ItemBox.cpp.

## ◆ onKeyButtonPressed()

void MyGUI::ItemBox::onKeyButtonPressed | ( | KeyCode | _key,
|  | Char | _char )
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 1019 of file MyGUI_ItemBox.cpp.

## ◆ onKeyButtonReleased()

void MyGUI::ItemBox::onKeyButtonReleased | ( | KeyCode | _key | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 1026 of file MyGUI_ItemBox.cpp.

## ◆ onKeyLostFocus()

void MyGUI::ItemBox::onKeyLostFocus | ( | Widget * | _new | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 221 of file MyGUI_ItemBox.cpp.

## ◆ onKeySetFocus()

void MyGUI::ItemBox::onKeySetFocus | ( | Widget * | _old | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 214 of file MyGUI_ItemBox.cpp.

## ◆ onMouseButtonPressed()

void MyGUI::ItemBox::onMouseButtonPressed | ( | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 534 of file MyGUI_ItemBox.cpp.

## ◆ onMouseButtonReleased()

void MyGUI::ItemBox::onMouseButtonReleased | ( | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 539 of file MyGUI_ItemBox.cpp.

## ◆ onMouseDrag()

void MyGUI::ItemBox::onMouseDrag | ( | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 544 of file MyGUI_ItemBox.cpp.

## ◆ onMouseWheel()

void MyGUI::ItemBox::onMouseWheel | ( | int | _rel | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 207 of file MyGUI_ItemBox.cpp.

## ◆ redrawAllItems()

void MyGUI::ItemBox::redrawAllItems | ( |  | ) |

Redraw all items.

Definition at line 823 of file MyGUI_ItemBox.cpp.

## ◆ redrawItemAt()

void MyGUI::ItemBox::redrawItemAt | ( | size_t | _index | ) |

Redraw at a specified position.

Definition at line 405 of file MyGUI_ItemBox.cpp.

## ◆ removeAllItems()

void MyGUI::ItemBox::removeAllItems | ( |  | ) |

Remove all items.

Definition at line 388 of file MyGUI_ItemBox.cpp.

## ◆ removeDropItems()

void MyGUI::ItemBox::removeDropItems | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 549 of file MyGUI_ItemBox.cpp.

## ◆ removeItemAt()

void MyGUI::ItemBox::removeItemAt | ( | size_t | _index,
|  | bool | update = true )

Remove item at a specified position.

Definition at line 355 of file MyGUI_ItemBox.cpp.

## ◆ resetCurrentActiveItem()

void MyGUI::ItemBox::resetCurrentActiveItem | ( |  | ) |
| protected

Definition at line 228 of file MyGUI_ItemBox.cpp.

## ◆ resetDrag()

void MyGUI::ItemBox::resetDrag | ( |  | ) |

Interrupt drag as if widget was dropped into empty space

Definition at line 828 of file MyGUI_ItemBox.cpp.

## ◆ setCoord() [1/2]

void MyGUI::ItemBox::setCoord | ( | const IntCoord & | _coord | ) |
| overridevirtual

Set widget position and size

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 87 of file MyGUI_ItemBox.cpp.

## ◆ setCoord() [2/2]

void MyGUI::Widget::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height )

See Widget::setCoord(const IntCoord& _coord)

Definition at line 179 of file MyGUI_Widget.cpp.

## ◆ setIndexSelected()

void MyGUI::ItemBox::setIndexSelected | ( | size_t | _index | ) |

Select specified _index.

Definition at line 417 of file MyGUI_ItemBox.cpp.

## ◆ setItemDataAt()

void MyGUI::ItemBox::setItemDataAt | ( | size_t | _index,
|  | Any | _data )

Replace an item data at a specified position.

Definition at line 309 of file MyGUI_ItemBox.cpp.

## ◆ setPosition() [1/2]

void MyGUI::ItemBox::setPosition | ( | const IntPoint & | _point | ) |
| overridevirtual

Set widget position (position of left top corner)

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 76 of file MyGUI_ItemBox.cpp.

## ◆ setPosition() [2/2]

void MyGUI::Widget::setPosition | ( | int | _left,
|  | int | _top )

See Widget::setPosition(const IntPoint& _pos)

Definition at line 175 of file MyGUI_Widget.cpp.

## ◆ setPropertyOverride()

void MyGUI::ItemBox::setPropertyOverride | ( | std::string_view | _key,
|  | std::string_view | _value )
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 930 of file MyGUI_ItemBox.cpp.

## ◆ setSize() [1/2]

void MyGUI::ItemBox::setSize | ( | const IntSize & | _size | ) |
| overridevirtual

Set widget size

Reimplemented from MyGUI::ICroppedRectangle.

Definition at line 81 of file MyGUI_ItemBox.cpp.

## ◆ setSize() [2/2]

void MyGUI::Widget::setSize | ( | int | _width,
|  | int | _height )

See Widget::setSize(const IntSize& _size)

Definition at line 177 of file MyGUI_Widget.cpp.

## ◆ setVerticalAlignment()

void MyGUI::ItemBox::setVerticalAlignment | ( | bool | _vert | ) |

Set vertical alignment grid mode

Definition at line 456 of file MyGUI_ItemBox.cpp.

## ◆ setViewOffset()

void MyGUI::ItemBox::setViewOffset | ( | const IntPoint & | _value | ) |

Set view area offset.

Definition at line 953 of file MyGUI_ItemBox.cpp.

## ◆ setVisibleHScroll()

void MyGUI::ItemBox::setVisibleHScroll | ( | bool | _value | ) |

Show HScroll when content size larger than view

Definition at line 914 of file MyGUI_ItemBox.cpp.

## ◆ setVisibleVScroll()

void MyGUI::ItemBox::setVisibleVScroll | ( | bool | _value | ) |

Show VScroll when content size larger than view

Definition at line 908 of file MyGUI_ItemBox.cpp.

## ◆ shutdownOverride()

void MyGUI::ItemBox::shutdownOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 68 of file MyGUI_ItemBox.cpp.

## ◆ updateDropItems()

void MyGUI::ItemBox::updateDropItems | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 555 of file MyGUI_ItemBox.cpp.

## ◆ updateDropItemsState()

void MyGUI::ItemBox::updateDropItemsState | ( | const DDWidgetState & | _state | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::DDContainer.

Definition at line 583 of file MyGUI_ItemBox.cpp.

## ◆ updateFromResize()

void MyGUI::ItemBox::updateFromResize | ( |  | ) |
| protected

Definition at line 106 of file MyGUI_ItemBox.cpp.

## ◆ updateMetrics()

void MyGUI::ItemBox::updateMetrics | ( |  | ) |
| protected

Definition at line 686 of file MyGUI_ItemBox.cpp.

## Field Documentation

## ◆ eventChangeItemPosition

EventHandle_ItemBoxPtrSizeT MyGUI::ItemBox::eventChangeItemPosition

Event : Position of selected item was changed.
signature : void method(MyGUI::ItemBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | item index

Definition at line 178 of file MyGUI_ItemBox.h.

## ◆ eventMouseItemActivate

EventHandle_ItemBoxPtrSizeT MyGUI::ItemBox::eventMouseItemActivate

Event : Click on item.
signature : void method(MyGUI::ItemBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | item index

Definition at line 185 of file MyGUI_ItemBox.h.

## ◆ eventNotifyItem

EventHandle_ItemBoxPtrCIBNotifyCellDataRef MyGUI::ItemBox::eventNotifyItem

Event : Notify about event in item widget.
signature : void method(MyGUI::ItemBox* _sender, const MyGUI::IBNotifyItemData& _info)

Parameters

  _sender | widget that called this event
  _info | info about item notify

Definition at line 192 of file MyGUI_ItemBox.h.

## ◆ eventSelectItemAccept

EventHandle_ItemBoxPtrSizeT MyGUI::ItemBox::eventSelectItemAccept

Event : Doubleclick or enter pressed on item.
signature : void method(MyGUI::ItemBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | item index

Definition at line 171 of file MyGUI_ItemBox.h.

## ◆ requestCoordItem

EventHandle_ItemBoxPtrIntCoordRefBool MyGUI::ItemBox::requestCoordItem

Event : Request for item coordinate.
signature : void method(MyGUI::ItemBox* _sender, MyGUI::IntCoord& _coord, bool _drag)

Parameters

  _sender | widget that called this event
  _coord | write heer item coordinate
  _drag | is this item dragging

Definition at line 156 of file MyGUI_ItemBox.h.

## ◆ requestCreateWidgetItem

EventHandle_ItemBoxPtrWidgetPtr MyGUI::ItemBox::requestCreateWidgetItem

Event : Request for creating new item.
signature : void method(MyGUI::ItemBox* _sender, MyGUI::Widget* _item)

Parameters

  _sender | widget that called this event
  _item | widget item pointer

Definition at line 148 of file MyGUI_ItemBox.h.

## ◆ requestDrawItem

EventHandle_ItemBoxPtrWidgetPtrCIBCellDrawInfoRef MyGUI::ItemBox::requestDrawItem

Event : Request for item redraw.
signature : void method(MyGUI::ItemBox* _sender, MyGUI::Widget* _item, const MyGUI::IBDrawItemInfo& _info)

Parameters

  _sender | widget that called this event
  _item | widget item pointer
  _info | item info

Definition at line 164 of file MyGUI_ItemBox.h.

The documentation for this class was generated from the following files:

- MyGUI_ItemBox.h
- MyGUI_ItemBox.cpp